import { Action } from './action';
export interface Reducer<T> {
    (state: T | undefined, action: Action<any, any>): T;
}
export interface Reducible<T extends object = {}> {
    reduce(action: Action<any, any>): T & Reducible<T & this>;
}
export declare type Reducibles<T extends object = any> = {
    [P in keyof T]: Reducible<T[P]>;
};
export interface ParametricReducibleFactory<D, T extends Reducibles> {
    data: D;
    type: T & Reducible<T>;
    buildReducer: (data: D) => Reducer<T>;
    (data: D): T & Reducible<T>;
}
export interface ReducibleFactory<T extends Reducibles> {
    type: T & Reducible<T>;
    buildReducer: () => Reducer<T>;
    (): T & Reducible<T>;
}
export declare function buildReducibleFactory<T extends Reducibles = object>(builder: () => T): ReducibleFactory<T>;
export declare function buildReducibleFactory<D = any, T extends Reducibles = object>(builder: (data: D) => T): ParametricReducibleFactory<D, T>;
